#include <math.h>

#include "mersenne.h"
#include "stdjunk.h"
#include "rnd.h"

fp_t 
rnd_uni(void)
{
  return genrand_real3();
}

/*
** gaussion random variable with zero mean and variance 1.0
*/
fp_t 
rnd_nrm(void)
{
  static int iset=0;
  static fp_t gset;
  fp_t fac,rsq,v1,v2;

  if  (iset == 0) {
    do {
      v1 = 2.0 * rnd_uni() - 1.0;
      v2 = 2.0 * rnd_uni() - 1.0;
      rsq = v1 * v1 + v2 * v2;
    } while (rsq >= 1.0 || rsq == 0.0);
    fac = sqrt(-2.0 * log(rsq) / rsq);
    gset=v1 * fac;
    iset = 1;
    return v2 * fac;
  }
  else {
    iset = 0;
    return gset;
  }
}


